# Running Tests

## Running Unit Tests

The library includes unit tests (Mocha) and can be run with the following command:

```
~$ npm test
```

The test will check the core module:

* `Pubsub`
* `Code`
* `CodeEngine`
* `Dispatcher`
* `Scheduler`


## Running Measurement Scripts

There are scripts included that can be used to collect performance measurements. For example, we can measure the time taken to instrument input code or time taken to capture a snapshot.

```
~$ npm run test-script <script_name> <sample_count> <test_name>
```

`<script_name>` can be one of the following:
* `instrument`
* `snapshot`
* `restore`
* `execute`

`<sample_count>` must be a natural number greater than zero.
`<test_name>` is the test session name; any output generated by the test will be prefixed with this string.


### Measuring Instrumentation

```
~$ npm run test-script instrument 100 test-01
```


### Measuring Snapshot

```
~$ npm run test-script snapshot 100 test-01
```


### Measuring Restoration

```
~$ npm run test-script restore 100 test-01
```


### Measuring Execution

```
~$ npm run test-script execute 3 test-01
```