# Background

The Internet of Things involves a plethora of interconnected devices that produce and consume large amounts of data. Over the last few years, the IoT landscape has grown tremendously, and applications can be found across multiple domains, both in academic and industrial circles.

While traditional IoT devices consist mostly of low-level embedded sensors and actuators, a more recent generation of devices has emerged. Such devices; e.g., the popular Raspberry Pi series, are getting more and more powerful and connected, and are quickly evolving beyond their traditional role of low-level embedded sensors and actuators to become more akin to embedded computers. As such, they can execute full operating systems, such as various distributions of Linux, thereby opening the door to running complex, rich and high-level applications directly on these devices, at the edge of the network (i.e., edge computing).

On the other hand, to bridge the heterogeneity of the IoT landscape, there is a strong incentive for establishing common paradigms and high-level abstractions. We believe this can be done through high-level, platform-independent languages and frameworks. Not confined anymore to the realms of the web, JavaScript has grown over the last few years as a mature and dynamic language on its own. Nowadays, JavaScript applications can be found in the desktop, mobile and server spaces, and more recently, in the IoT world.

# What is ThingsJS?

ThingsJS is a comprehensive platform for designing and deploying high-level edge applications written in JavaScript onto the IoT devices themselves, in combination with the cloud. ThingsJS provides:
- a set of APIs and high-level services for developers;
- a set of self-adaptation features;
- rich graphical and console-based user interfaces to observe and interact with the system.
