'use strict'
var stream = require('stream');
var helpers = require('../helpers.js');
var Pubsub = require('./Pubsub.js');


/**
 * A Pipe object is used to redirect a source stream's output to a target object's input stream.
 * @param {Pubsub} pubsub     [description]
 * @param {ReadableStream} stream_in  [description]
 * @param {WritableStream} stream_out [description]
 */
function Pipe(pubsub, stream_in, stream_out){
	this.pubsub = pubsub;
	this.from = stream_in;
	this.to = stream_out;

	this.from.on('data', function(chunk){

	});
}


function InputStream(pubsub, topic){
	if (!(this instanceof InputStream)) return new InputStream(pubsub, topic);
	stream.Readable.call(this, {});
	var self = this;
	this.id = Math.random();
	this.bytesRead = 0;		// fs.ReadStream property

	pubsub.subscribe(topic, function(message, topic, rawBuffer){
		self.push(rawBuffer);
	});
	
	this._read = function(size){
		this.bytesRead += size;
	}
}
InputStream.prototype = new stream.Readable();


function OutputStream(pubsub, topic){
	if (!(this instanceof OutputStream)) return new OutputStream(pubsub, topic);
	stream.Writable.call(this, {});
	var self = this;
	this.id = Math.random();
	// this.bytesRead = 0;		// fs.ReadStream property

	// var requests = {}
	
	// pubsub.subscribe(codeId+'/fs/WriteStream/'+self.id+'/ack', function(message){
	// 	if (message.request in requests) requests[message.request].resolve(true);
	// 	else reject("Request already resolved");
	// 	delete requests[message.request];
	// })

	this._write = function(chunk, encoding, callback){
		// var request = Math.random();
		// requests[request] = defer();
		// requests[request].promise.then(function(){
		// 	callback(null);
		// }, function(err){
		// 	callback(err);
		// });

		pubsub.publish(topic, chunk)
			.then(function(result){
				callback(null);
			}, function(error){
				callback(error);
			})
	}
}
OutputStream.prototype = new stream.Writable();
