/**
 * Controls a Servo Motor
 * inputs:
 *   - {id}/cmd : Command to send to this controller
 * outputs:
 *   - {id}/logs : text/plain
 */
/*things.meta
inputs:
  id/cmd: application/json
outputs:
  id/logs : text/plain
*/
var things = require('things-js');

var pubsub_url = 'mqtt://localhost';
var pubsub = new things.Pubsub(pubsub_url);

var state = {
	angle: 0
}

var Behaviours = {
	'turnLeft': function(){
		return new Promise(function(resolve, reject){
			state.angle += -90;

			resolve({
				result: 'success',
				state: Object.assign({}, state)
			});
		})
	},
	'turnRight': function(){
		return new Promise(function(resolve, reject){
			state.angle += 90;

			resolve({
				result: 'success',
				state: Object.assign({}, state)
			});
		})
	}
}

function ProcessCommand(data){
	Behaviours[data.ctrl]()
		.then(function(result){
			pubsub.publish(pubsub.id+'/logs', {
				timestamp: Date.now(),
				action: data.ctrl,
				state: Object.assign({}, state)
			})
		})
}

pubsub.on('ready', function(){
    console.log("Pubsub connected");
    pubsub.subscribe(pubsub.id+'/cmd', ProcessCommand);
});